<?xml version="1.0" encoding="UTF-8"?>
<!-- rc9232v2u1.xslt, juli 2020 -->
<xsl:stylesheet version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:fz="http://ei.vektis.nl/verantwoording/basisschema/v2_0"
 xmlns:fz812="http://ei.vektis.nl/verantwoording/fz812/v2_0">

	<!-- retourcode 9232: Aantal dagen moet overeenkomen met periode tussen BegindatumPrestatie en EinddatumPrestatie.-->
	<xsl:template name="rc9232">
		
		<xsl:param name="TijdseenheidZorgperiode"/>
		<xsl:param name="Aantaldagen"/>
		<xsl:param name="BegindatumPrestatie"/>
		<xsl:param name="EinddatumPrestatie"/>
		
		<xsl:variable name="JaarBegindatumPrestatie" select="substring($BegindatumPrestatie,1,4)"/>
		<xsl:variable name="JaarEinddatumPrestatie" select="substring($EinddatumPrestatie,1,4)"/>
		
			<xsl:if test="$JaarBegindatumPrestatie = $JaarEinddatumPrestatie">
			<xsl:variable name="Periode">
				<xsl:call-template name="date-difference">
					<xsl:with-param name="from-year" select="substring($BegindatumPrestatie,1,4)"/>
					<xsl:with-param name="from-month" select="substring($BegindatumPrestatie,5,2)"/>
					<xsl:with-param name="from-day" select="substring($BegindatumPrestatie,7,2)"/>
					<xsl:with-param name="to-year" select="substring($EinddatumPrestatie,1,4)"/>
					<xsl:with-param name="to-month" select="substring($EinddatumPrestatie,5,2)"/>
					<xsl:with-param name="to-day" select="substring($EinddatumPrestatie,7,2)"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:if test="($Aantaldagen != $Periode) and ($TijdseenheidZorgperiode = '14')">
				<fz812:Retourcode>9232</fz812:Retourcode>
			</xsl:if>
		</xsl:if>
			
		<xsl:if test="$JaarBegindatumPrestatie != $JaarEinddatumPrestatie">
			<xsl:variable name="Periode">
				<xsl:call-template name="date-difference">
					<xsl:with-param name="from-year" select="substring($BegindatumPrestatie,1,4)"/>
					<xsl:with-param name="from-month" select="substring($BegindatumPrestatie,5,2)"/>
					<xsl:with-param name="from-day" select="substring($BegindatumPrestatie,7,2)"/>
					<xsl:with-param name="to-year" select="substring($EinddatumPrestatie,1,4)"/>
					<xsl:with-param name="to-month" select="substring($EinddatumPrestatie,5,2)"/>
					<xsl:with-param name="to-day" select="substring($EinddatumPrestatie,7,2)"/>
				</xsl:call-template>
			</xsl:variable>
			<xsl:if test="($Aantaldagen != $Periode) and ($TijdseenheidZorgperiode = '14')">
				<fz812:Retourcode>9232</fz812:Retourcode>
			</xsl:if>
		</xsl:if>
		
	</xsl:template>
		
	<xsl:template name="date-difference">
     <xsl:param name="from-year"/>
		<xsl:param name="from-month"/>
		<xsl:param name="from-day"/>
		<xsl:param name="to-year"/>
		<xsl:param name="to-month"/>
		<xsl:param name="to-day"/>
		   
		<xsl:variable name="jd1">
			<xsl:call-template name="calculate-julian-day">
				<xsl:with-param name="year" select="$from-year"/>
				<xsl:with-param name="month" select="$from-month"/>
				<xsl:with-param name="day" select="$from-day"/>
			</xsl:call-template>
		</xsl:variable>
		   
		<xsl:variable name="jd2">
			<xsl:call-template name="calculate-julian-day">
				<xsl:with-param name="year" select="$to-year"/>
			   <xsl:with-param name="month" select="$to-month"/>
			   <xsl:with-param name="day" select="$to-day"/>
			</xsl:call-template>
		</xsl:variable>
			
		<!-- Er wordt 'tot' berekend en gewenst is 'tot en met', dus + 1 -->   
		<xsl:value-of select="$jd2 - $jd1 + 1"/>
	</xsl:template>
		
	<xsl:template name="calculate-julian-day">
		 <xsl:param name="year"/>
		 <xsl:param name="month"/>
		 <xsl:param name="day"/>
		   
		<xsl:variable name="a" select="floor((14 - $month) div 12)"/>
		<xsl:variable name="y" select="$year + 4800 - $a"/>
		<xsl:variable name="m" select="$month + 12 * $a - 3"/>
		   
		<xsl:value-of select="$day + floor((153 * $m + 2) div 5) + $y * 365 + floor($y div 4) - floor($y div 100) + floor($y div 400) - 32045"/>
		   
	</xsl:template>

</xsl:stylesheet>
